SystemOrganization addCategory: #'Handles-SmartClone-Experimentation'!
SystemOrganization addCategory: #'Handles-SmartClone'!
SystemOrganization addCategory: #'Handles-Core'!
SystemOrganization addCategory: #'Handles-ExperimentationCWIP'!
SystemOrganization addCategory: #'Handles-BrokenTests'!
SystemOrganization addCategory: #'Handles-FactoryPattern'!
SystemOrganization addCategory: #'Handles-CriticalTests'!
SystemOrganization addCategory: #'Handles-Tests-Kernel'!
SystemOrganization addCategory: #'Handles-TransactionnalMemoryCWIP'!
SystemOrganization addCategory: #'Handles-Watcher'!
SystemOrganization addCategory: #'Handles-Documentations'!
SystemOrganization addCategory: #'Handles-ApplicationMirrorAPI'!
SystemOrganization addCategory: #'Handles-Tests-HandlesClasses'!
SystemOrganization addCategory: #'Handles-Tests-Classes'!
SystemOrganization addCategory: #'Handles-Tests-Transaction'!
SystemOrganization addCategory: #'Handles-Tests-Security'!
SystemOrganization addCategory: #'Handles-Security-Revocables'!
SystemOrganization addCategory: #'Handles-Security-LimitedInterface'!
SystemOrganization addCategory: #'Handles-Benchmark'!
SystemOrganization addCategory: #'Handles-Worlds'!
SystemOrganization addCategory: #'Handles-DesigningTM'!

Error subclass: #AccessRevoqued
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-Revocables'!

!AccessRevoqued class methodsFor: 'as yet unclassified' stamp: 'jb 2/4/2011 14:16'!
signal 

^self new 
		messageText: 'Your access has been revoque. Looser';
		signal.! !

!AccessRevoqued methodsFor: 'as yet unclassified' stamp: 'jb 2/4/2011 14:16'!
signal
	^super signal.! !

!SmalltalkImage methodsFor: '*handles' stamp: 'jb 1/4/2012 14:44'!
recreateSpecialObjectsArrayForHandle
	"Smalltalk recreateSpecialObjectsArrayForHandle"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 58.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray at: 31 put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: Point new.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes (yeah, right)"
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 36 put: (self specialObjectsArray at: 36). "Is the prototype MethodContext (unused by the VM)"
	newArray at: 37 put: BlockClosure.
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 38 put: (self specialObjectsArray at: 38). "Is the prototype BlockContext (unused by the VM)"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"preserve external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: nil. "Reserved for a LinkedList instance for overlapped calls in CogMT"
	"finalization Semaphore"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	"newArray at: 51 put: #attemptToAssign:withIndex:."
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallback:stack:registers:jmpbuf:.
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Weak reference finalization"
	newArray at: 56 put: (self at: #WeakFinalizationList ifAbsent: []).

	"add Handle behavior"
	newArray at: 57 put: Handle.
	newArray at: 58 put: #propagateTo:.
	"Now replace the interpreter's reference in one atomic operation"

	self specialObjectsArray become: newArray
	! !

!Array methodsFor: '*handles' stamp: 'jeanbaptistearnaud 4/12/2012 14:45'!
installState
	<primitive:'primitiveInstallAll'>
	self primitiveFailed.! !

Array variableSubclass: #HandleTestClass
	instanceVariableNames: 'inst1 inst2 inst3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Classes'!

!HandleTestClass class methodsFor: 'as yet unclassified' stamp: 'jb 10/5/2011 15:53'!
new
	^(super new:3) initialize! !

!HandleTestClass methodsFor: 'basic test' stamp: 'jeanbaptistearnaud 5/9/2012 15:22'!
= anObject
	(anObject isKindOf: self class) ifFalse:[^false].
	(self qInst1= anObject qInst1) ifFalse: [^false].
	(self inst2 = anObject inst2) ifFalse: [^false].
	(self inst3 = anObject inst3) ifFalse: [^false].
	((self at: 1) = (anObject at: 1))ifFalse: [^false].
	((self at: 2) = (anObject at: 2))ifFalse: [^false].
	((self at: 3) = (anObject at: 3))ifFalse: [^false].
	^true.! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:53'!
initialize
	inst1 := 42.
	self basicAt: 1 put: 24! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:35'!
inst1: anObject

	inst1 := anObject! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:35'!
inst2

	^ inst2! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:35'!
inst2: anObject

	inst2 := anObject! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:35'!
inst3

	^ inst3! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/5/2011 15:35'!
inst3: anObject

	inst3 := anObject! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/12/2011 16:28'!
nQInst1
1+2.
	^ inst1! !

!HandleTestClass methodsFor: 'primitives' stamp: 'jb 10/5/2011 15:39'!
primitiveAt: anObject
	<primitive:60>
	^self error! !

!HandleTestClass methodsFor: 'primitives' stamp: 'jb 10/5/2011 15:41'!
primitiveAt: anObject put: anotherObject
	<primitive:61>
	^self error! !

!HandleTestClass methodsFor: 'accessing' stamp: 'jb 10/12/2011 16:27'!
qInst1

	^ inst1! !

!HandleTestClass methodsFor: 'basic test' stamp: 'jb 10/10/2011 13:21'!
success
	^'success'! !

ProtoObject subclass: #HowDoUseHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Documentations'!

!HowDoUseHandle class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testImageForHandle
	^[(SmalltalkImage current specialObjectsArray at: 51) == Handle] on: Error do:[false]! !

!HowDoUseHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:48'!
testVirtualMachineForHandle
	[(Handle new) activateHandle] on: Error do: [^false].
	^true.! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleFirstStep
	^ Lesson title: 'handle first indirection' lesson: '"The API for using handle is very simple."
|a handleOfA |
"If you want to create a Handle"

a := A new. "create a instance of A"

handleOfA := Handle for: a to: B. "We create a handle on ''a'' and redirect the behavior to B"

"That mean all the message send to a will be execute with method dictionnary of A"
a isA.
a isB.


"That mean all the message send to handleOfA will be execute with method dictionnary of B"

handleOfA isA.
handleOfA isB.

ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleFourStep
	^ Lesson title: 'handle ' lesson: '"Advance use of Handle. Need to have fine grain configuration :"
	
"All access API	
Basic access
Handle for: (Object new).  => create a Handle that do indirection on state of the object.
Handle for: (Object new) to: Class. => create a handle that do indirection on behavior of the object redirect to the class."

"Fine Grain configuration"
Handle debugFor: (Object new). " => create a non activate handle, which your are able to configure using the configuration interface. but initialize the value of the state indirection."
Handle debugFor: (Object new) to: Class. " => create a non activate handle, which your are able to configure using the configuration interface. but initialize the value of the behavior indirection."

"accessor
receiver & receiver: is the target object behind the handle. Should be initialize.
classLookup & classLookup: : is a accessor to where the lookup should begin. Should be initialize if you would like to have behavior indirection.

Configuration interface
addBehavior & removeBehavior => enable/disable the behavior indirection.
addState & removeState => enable/disable the state indirection.
addSelfWrapping & addSelfWrapping => enable/disable the behavior such self representing the receiver or a handle on receiver, it is wrap then self represent a handle on receiver.

Activate Handle
is do by sending the message becomeHandle to a unactivate handle."

(Handle debugFor: (Object new))
	classLookup: Object;
	addBehavior;
	becomeHandle.

"create a handle doing indirection on behavior and state"

(Handle debugFor: (Object new))
	classLookup: Object;
	addBehavior;
	removeState;
	becomeHandle.
	
"do the same thing than"
Handle for: (Object new) to: Object.


ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleMeta
	^ Lesson title: 'Smell like meta ? ' lesson: '
"At origine the Handle was design for control execution flow, but once activate you don''t have any control on it that why we can create a MetaHandle"	
"A MetaHandle is a Handle defining the behavior on a Handle, is a direct subclass of handle."
"Create a MetaHandle One security restriction, you should create the MetaHandle before activating the handle. For a simple question of security you should not escape from handle"


|metaH handle |

handle := Handle debugFor: (A new) to: B.
metaH := MetaHandle for: handle.
handle becomeHandle.

"Then now you can do funny thing like changing indirection during execution just by sending a message to MetaHandle"
handle isB. 
metaH classLookup: A.
handle isA.
handle var1. "''var1''"
metaH addState.
handle var1: ''state save''.
handle var1.  "''state save''"
metaH removeState
handle var1."  ''var1''"
metaH addState.
handle var1.  "''state save''"

"Be care to not lost the Reference MetaHandle or you can not changing the handle anymore !!!!"

"It''s enough for the core of Handle"
ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handlePreTest
	^ Lesson title: 'handle support?' lesson: '"A handle is a special object that allow you to do indirection behavior or on state.
He need to use a special VM, and have to do some modification on your image.
That why before begining we should check your VM :"

HowDoUseHandle testVirtualMachineForHandle.
" If this test fails, you can find the virtual machine needed to use handle at this adress:
http://dl.dropbox.com/u/7879914/HandleLast.zip

AndTestYourImage :"
HowDoUseHandle testImageForHandle.

"If this test fails, you can load the code by loading the configurationOfHandle"

ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handlePrinciple
	^ Lesson title: 'handle principle' lesson: '"
As we say previously Handle is a special object that allow you to create indirection on Behavior or on State.
This tutorial, is separate in 3 Step,
	- Learn the Core model of The Handle and How to use it.
	- Learn how use the different application created for the handle.
	- And learn how extend Handles to create your specifique indirection on Handle.

the core Model of Handle is pretty simple, is just composed of 2 class,
Handle : Handle is a object know by the VM, it''s represent a indirection, do on a object, such a transparent proxy.

MetaHandle : MetaHandle is Handle which able to configure the Handle. We need this object because once we activate a handle, is become a unreachable object. Invisible From the image part."


ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleSecondStep
	^ Lesson title: 'handle ' lesson: '"The API for using handle is very simple."
"a important point, the object access by the handle is not a copy of the object it''s the same object : "

"concequently a object and this handle have the SAME identity because he represente just a another version of the same object.
try "
|a handleOfA |
a := A new. "create a instance of A"
handleOfA := Handle for: a to: AA. "We create a handle on ''a'' and redirect the behavior to AA a subclassOfA"
a == handleOfA.

"In addition, if the someone change one of this reference that will change the other reference"

a := A new.
handleOfA := Handle for: a to: AA. 
a var1: ''test''.
handleOfA var1 = ''test''.
handleOfA var1: ''test2''.
a var1 = ''test2''.


ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleThirdStep
	^ Lesson title: 'handle ' lesson: '"The other skill of the handle is to create indirection on State

That mean you can create a Handle, which keep this own state.
try"
|a handleOfA |
a := A new.
handleOfA := Handle for: a. 
a var1: ''test''.
handleOfA var1 = ''test''.
handleOfA var1: ''test2''.
a var1 = ''test2''.



ProfStef next.'! !

!HowDoUseHandle methodsFor: 'lesson' stamp: 'JB 12/2/2010 15:07'!
handleWhatIsIt
	^ Lesson title: 'handle support?' lesson: '"A handle is a special object that allow you to do indirection behavior or on state.
He need to use a special VM, and have to do some modification on your image.
That why before begining we should check your VM :"

HowDoUseHandle testVirtualMachine.
" If this test fails, you can find the virtual machine needed to use handle at this adress:
http://dl.dropbox.com/u/7879914/HandleLast.zip
" 
AndTestYourImage :"
HowDoUseHandle testImage.
"If this test fails, you can load the code by loading the configurationOfHandle""

ProfStef next.'! !

!HowDoUseHandle methodsFor: 'tutorial' stamp: 'JB 12/2/2010 15:07'!
tutorial
	^ #(#handlePreTest handlePrinciple handleFirstStep handleSecondStep handleThirdStep handleFourStep handleMeta)! !

!ProtoObject methodsFor: '*handles' stamp: 'jb 4/6/2011 09:52'!
asRevocable
	^ControllerFactory for: self.! !

TestCase subclass: #AbstractLimitedCategoryIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!AbstractLimitedCategoryIterator class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:10'!
isAbstract

	^ self name = #AbstractLimitedCategoryIterator.! !

!AbstractLimitedCategoryIterator methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 18:38'!
accessShouldBeDenied
	^#()! !

!AbstractLimitedCategoryIterator methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:04'!
accessShouldBeGrant
	^#().! !

!AbstractLimitedCategoryIterator methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:07'!
createDummyHandle
	^nil! !

!AbstractLimitedCategoryIterator methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:44'!
testAllAccessDenied
"future sight what we do ...
	- perform. i think overload it in VM.

"
"	| aObject |
	aObject := self createDummyHandle.
	self accessShouldBeDenied do: [ :each |
		self should:	[aObject perform: each]
			raise: MessageNotUnderstood.
		]."! !

!AbstractLimitedCategoryIterator methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 18:53'!
testMyTestIsNotComplete

	self assert: ((self accessShouldBeDenied asOrderedCollection addAll: (self accessShouldBeGrant asOrderedCollection);yourself) includesAllOf: (self createDummyHandle class methodDict)keys ).! !

AbstractLimitedCategoryIterator subclass: #HandleCategoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!HandleCategoryTest methodsFor: 'superclass' stamp: 'jb 3/8/2011 18:41'!
accessShouldBeDenied
	^#(#thisIsPrivateMethod #anotherPublicMethod).! !

!HandleCategoryTest methodsFor: 'superclass' stamp: 'jb 3/8/2011 18:41'!
accessShouldBeGrant
	^#(#storeAndReturnSelf #storeAndReturnSelf2 #takeCareAboutSelf #thisIsPublic #thisIsPublicInterface).! !

!HandleCategoryTest methodsFor: 'superclass' stamp: 'jb 3/8/2011 18:21'!
createDummyHandle
	^(CategoryHandle for: (LimitedInterfaceTestClass new) categories: #( #public))! !

!HandleCategoryTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:31'!
testMultipleCategories
	|anObject|
 	anObject := LimitedInterfaceTestClass new.	
	self should: [(CategoryHandle for: anObject categories: #( #public)) thisIsPrivateMethod] raise: MessageNotUnderstood.
	
	self shouldnt: [(CategoryHandle for: anObject categories: #( #public)) thisIsPublicInterface.] raise: MessageNotUnderstood.
	
	self shouldnt: [(CategoryHandle for: anObject categories: #( #public)) thisIsPublic.] raise: MessageNotUnderstood.
	
	self assert: ((CategoryHandle for: anObject categories: #( #public)) thisIsPublicInterface =  'You access to a private zone').
	
	self assert: ((CategoryHandle for: anObject categories: #( #public)) thisIsPublic =  'It is public').
	
	self shouldnt: [(CategoryHandle for: anObject categories: #(  #public #anotherPublic)) anotherPublicMethod.] raise: MessageNotUnderstood.
	
	self assert: ((CategoryHandle for: anObject categories: #(  #public #anotherPublic)) anotherPublicMethod =  'this Is Public')
! !

!HandleCategoryTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:31'!
testSingleCategory
|anObject|
 	anObject := LimitedInterfaceTestClass new.	
	
	
	self should: [(CategoryHandle for: anObject categories: #( #public)) thisIsPrivateMethod] raise: MessageNotUnderstood.
	
	self shouldnt: [(CategoryHandle for: anObject categories: #( #public)) thisIsPublicInterface.] raise: MessageNotUnderstood.
	
	self shouldnt: [(CategoryHandle for: anObject categories: #( #public)) thisIsPublic.] raise: MessageNotUnderstood.
	
	self assert: ((CategoryHandle for: anObject categories: #( #public)) thisIsPublicInterface =  'You access to a private zone').
	
	self assert: ((CategoryHandle for: anObject categories: #( #public)) thisIsPublic =  'It is public').! !

AbstractLimitedCategoryIterator subclass: #HandleLimitedInterfaceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!HandleLimitedInterfaceTest methodsFor: 'testloop' stamp: 'jb 3/8/2011 18:41'!
accessShouldBeDenied
	^#(#thisIsPrivateMethod #anotherPublicMethod).! !

!HandleLimitedInterfaceTest methodsFor: 'testloop' stamp: 'jb 3/8/2011 18:39'!
accessShouldBeGrant
	^#(#storeAndReturnSelf #storeAndReturnSelf2 #takeCareAboutSelf #thisIsPublic #thisIsPublicInterface).! !

!HandleLimitedInterfaceTest methodsFor: 'testloop' stamp: 'jb 3/8/2011 18:39'!
createDummyHandle

	^(LimitedInterfaceHandle for: (LimitedInterfaceTestClass new) with: (self accessShouldBeGrant)).! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:33'!
testLimitedInterfacePrivateAccess

|anObject|
 	anObject := LimitedInterfaceTestClass new.	
		
	self
		should: [(LimitedInterfaceHandle for: anObject with: #(#thisIsPublicInterface )) thisIsPrivateMethod]
		raise: MessageNotUnderstood! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:32'!
testLimitedInterfacePrivateThroughtPublicAccess

|anObject|
 	anObject := LimitedInterfaceTestClass new.	
		
	self
		shouldnt: [(LimitedInterfaceHandle for: anObject with: #(#thisIsPublicInterface )) thisIsPublicInterface]
		raise: MessageNotUnderstood.
	self assert: (LimitedInterfaceHandle for: anObject with: #(#thisIsPublicInterface )) thisIsPublicInterface = 'You access to a private zone'! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:33'!
testLimitedInterfacePublicAccess


|anObject|
 	anObject := LimitedInterfaceTestClass new.	
	self
		shouldnt: [(LimitedInterfaceHandle for: anObject with: #(#thisIsPublic )) thisIsPublic]
		raise: MessageNotUnderstood.
	self assert: (LimitedInterfaceHandle for: anObject with: #(#thisIsPublic )) thisIsPublic = 'It is public'! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:33'!
testLimitedInterfaceSelfTest


|anObject|
 	anObject := LimitedInterfaceTestClass new.	

	self
		shouldnt: [(LimitedInterfaceHandle for: anObject with: #(#takeCareAboutSelf )) takeCareAboutSelf]
		raise: MessageNotUnderstood.
	self
		should: [(LimitedInterfaceHandle for: anObject with: #(#takeCareAboutSelf )) takeCareAboutSelf thisIsPrivateMethod]
		raise: MessageNotUnderstood! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:34'!
testLimitedInterfaceStoreAndReturnSelf

|anObject|
 	anObject := LimitedInterfaceTestClass new.	


	self
		shouldnt: [(LimitedInterfaceHandle for:  anObject with: #(#storeAndReturnSelf )) storeAndReturnSelf]
		raise: MessageNotUnderstood.
	self
		should: [(LimitedInterfaceHandle for: anObject with: #(#storeAndReturnSelf )) storeAndReturnSelf thisIsPrivateMethod]
		raise: MessageNotUnderstood! !

!HandleLimitedInterfaceTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:34'!
testLimitedInterfaceStoreAndReturnSelfInstance

|anObject|
 	anObject := LimitedInterfaceTestClass new.	

	self
		shouldnt: [(LimitedInterfaceHandle for: anObject with: #(#storeAndReturnSelf2 )) storeAndReturnSelf2]
		raise: MessageNotUnderstood.
	self
		should: [(LimitedInterfaceHandle for: anObject with: #(#storeAndReturnSelf2 )) storeAndReturnSelf2 thisIsPrivateMethod]
		raise: MessageNotUnderstood! !

AbstractLimitedCategoryIterator subclass: #HandlePragmaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!HandlePragmaTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 18:40'!
accessShouldBeDenied
	^#(#thisIsPrivateMethod #anotherPublicMethod).! !

!HandlePragmaTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 18:39'!
accessShouldBeGrant
	^#(#storeAndReturnSelf #storeAndReturnSelf2 #takeCareAboutSelf #thisIsPublic #thisIsPublicInterface).! !

!HandlePragmaTest methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:34'!
createDummyHandle
	^(PragmaHandle for: (LimitedInterfaceTestClass new) pragmas: #(#public #againPublic))! !

TestCase subclass: #ClassHandleTest
	instanceVariableNames: 'className renamedName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-BrokenTests'!

!ClassHandleTest methodsFor: 'setup' stamp: 'JB 12/2/2010 15:07'!
deleteClass
	| mustRemove |
	mustRemove := Smalltalk globals
				at: className
				ifAbsent: [^ self].
	mustRemove removeFromChanges; removeFromSystemUnlogged! !

!ClassHandleTest methodsFor: 'setup' stamp: 'JB 12/2/2010 15:07'!
deleteRenamedClass
	| mustRemove |
	mustRemove := Smalltalk globals
				at: renamedName
				ifAbsent: [^ self].
	mustRemove removeFromChanges; removeFromSystemUnlogged! !

!ClassHandleTest methodsFor: 'functional test' stamp: 'JB 12/2/2010 15:07'!
expectedFailures
	^#(#testCreationMethodOnHandle).! !

!ClassHandleTest methodsFor: 'setup' stamp: 'JB 12/2/2010 15:07'!
tearDown
	self deleteClass.
	self deleteRenamedClass! !

!ClassHandleTest methodsFor: 'testing' stamp: 'JB 12/2/2010 15:07'!
testAddInstVarName
	| classHandle |
	classHandle := ClassHandle for: A.
	classHandle addInstVarName: 'x'.
	self assert: classHandle instVarNames = #('x' ).
	classHandle addInstVarName: 'y'.
	self assert: classHandle instVarNames = #('x' 'y' )! !

!ClassHandleTest methodsFor: 'testing - class variables' stamp: 'JB 12/2/2010 15:07'!
testClassVarNames
	self
		assert: ((ClassHandle for: A) classVarNames includes: #Coucou).
	self assert: (ClassHandle for: A) classVarNames = (ClassHandle for: A) class classVarNames! !

!ClassHandleTest methodsFor: 'testing - compiling' stamp: 'jb 2/7/2011 13:50'!
testCompileAll
	self
		shouldnt: [(ClassHandle for: FooBar) compileAll]
		raise: Error! !

!ClassHandleTest methodsFor: 'functional test' stamp: 'JB 12/2/2010 15:07'!
testCreationMethodOnHandle
	"| t1 t2 t3 t4 |
	t3 := PropagationTestClass new.
	t1 := RewriteMethodWithPropagationHandle
				debugFor: t3
				rule: [].
	t4 := t1 classLookup.
	t1 becomeHandle.
	t4 compile: 'testToRemove ^false'.
	self
		shouldnt: [t1 testToRemove]
		raise: MessageNotUnderstood.
	self
		should: [t3 testToRemove]
		raise: MessageNotUnderstood"! !

!ClassHandleTest methodsFor: 'testing' stamp: 'JB 12/2/2010 15:07'!
testRenaming
	^ self! !

TestCase subclass: #HandleClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

HandleClassTest subclass: #ClassHandleBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleAddBehavior
| cha ast cm |
	cha := (self handleClassClass) for: Object. 
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: cha parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: cha.
	cha addSelectorSilently: #answer withMethod: cm.
	self assert: (cha methodDict includesKey: #answer).
	self deny: (Object methodDict includesKey: #answer)! !

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleNew
| cha ha |
	cha := (self handleClassClass) for: Object. 
	ha := cha new.
	self assert: (ha isKindOf: Object).! !

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleNewAddBehaviorAfter
| cha ha ast cm |
	cha := (self handleClassClass) for: Object. 
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: cha parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: cha.
	cha addSelectorSilently: #answer withMethod: cm.
	ha := cha new.
	self shouldnt: (ha answer) raise: Error.
	self assert: (ha answer = 42).
	! !

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleNewAddBehaviorBefore
| cha ha ast cm |
	cha := (self handleClassClass) for: Object. 
	ha := cha new.
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: cha parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: cha.
	cha addSelectorSilently: #answer withMethod: cm.
	self shouldnt: (ha answer) raise: Error.
	self assert: (ha answer = 42).
	! !

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleNewRemoveBehavior
| cha ha ast cm |
	cha := (self handleClassClass) for: Object. 
	ha := cha new.
	cha methodDict removeKey: #asString.
	"self should: (ha asString) raise: Error."
	! !

!ClassHandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:24'!
testClassHandleRemoveBehavior
| cha ast cm |
	cha := (self handleClassClass) for: Object. 
	cha methodDict removeKey: #=.
	self deny: (cha methodDict includesKey: #=).
	self assert: (Object methodDict includesKey: #=)! !

HandleClassTest subclass: #HandleBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 13:48'!
testInterceptMessage
	| handle |
	handle := self handleClass initializeFor: (Object new) to: (self testClass).
	handle useShadowBehavior; dontUseState; activateHandle.
	self assert: handle success = 'success'! !

!HandleBehaviorTest methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 14:59'!
testdontChangeOriginalObject
	| trueObject handle |
	trueObject := Object new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle useShadowBehavior; dontUseState; activateHandle.
	self should: [trueObject success] raise: Error.
	self assert: (handle success = 'success').! !

!HandleClassTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:23'!
handleClass
	^SCHandle! !

!HandleClassTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:22'!
handleClassClass
	^ClassSCHandle! !

!HandleClassTest methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 14:23'!
handleMetaClass
	^MetaclassSCHandle! !

!HandleClassTest methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 13:48'!
testClass
	^HandleTestClass! !

HandleClassTest subclass: #HandleIdentityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandleIdentityTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testIdentityObject1
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle dontUseShadowBehavior; dontUseState; activateHandle.
	self assert: trueObject == handle! !

!HandleIdentityTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testIdentityObject2
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest .
	handle useShadowBehavior; dontUseState; activateHandle.
	self assert: trueObject == handle! !

!HandleIdentityTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testIdentityObject3
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle dontUseShadowBehavior; useHandleState; activateHandle.
	self assert: trueObject == handle! !

!HandleIdentityTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testIdentityObject4
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle dontUseShadowBehavior; dontUseState; activateHandle.
	self assert: trueObject == handle! !

!HandleIdentityTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testReverseIdentityObject1
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle activateHandle.
	self assert: handle == trueObject! !

HandleClassTest subclass: #HandleMetaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandleMetaTest methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 10:03'!
changeShadowBehavior! !

HandleClassTest subclass: #HandlePrimitiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandlePrimitiveTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:17'!
testPrimitive60At
	| inst hinst |
	inst := (self testClass) new.
	hinst := self handleClass for: inst.
	self assert: ((hinst primitiveAt: 1) = 24).! !

!HandlePrimitiveTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:17'!
testPrimitive61AtPut
	| inst hinst |
	inst := self testClass new.
	hinst := self handleClass for: inst.
	self shouldnt: (hinst primitiveAt: 1 put: 25) raise: Error.
	self assert: ((hinst primitiveAt: 1) = 25).! !

HandleClassTest subclass: #HandlePropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandlePropagationTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:23'!
handleClass
	^IncrementHandle! !

!HandlePropagationTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:49'!
testHandlePropagateBytecodePushReceiver
| trueObject handle |
	trueObject :=  (self testClass) new.
	handle := self handleClass for: trueObject.
	self assert: (handle nQInst1 = 43)! !

!HandlePropagationTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:35'!
testHandlePropagatePrimitiveBasicAt
	| inst hinst |
	inst := (self testClass) new.
	hinst := self handleClass for: inst.
	self assert: ((hinst primitiveAt: 1) = 25).! !

!HandlePropagationTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:34'!
testHandlePropagatePrimitiveInstVarAt
	| inst hinst |
	inst := (self testClass) new.
	hinst := self handleClass for: inst.
	self assert: ((hinst instVarAt: 1) = 43).! !

!HandlePropagationTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:48'!
testHandlePropagateQuickReturn
| trueObject handle |
	trueObject :=  (self testClass) new.
	handle := self handleClass for: trueObject.
	self assert: (handle qInst1 = 43)! !

HandleClassTest subclass: #HandleSelfWrappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandleSelfWrappingTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:20'!
testActiveSelfWrap
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle useShadowBehavior; 	activateSelfRepresentHandleAndActivateReturnWrapping;
	activateHandle.
	self
		shouldnt: [handle activeTestWrap]
		raise: MessageNotUnderstood! !

!HandleSelfWrappingTest methodsFor: 'as yet unclassified' stamp: 'jb 1/4/2012 15:19'!
testDesactiveSelfWrap
	| trueObject handle |
	trueObject := HandleClassTest new.
	handle := self handleClass initializeFor: trueObject to: HandleClassTest.
	handle useShadowBehavior; 	desactivateSelfRepresentHandleAndActivateReturnWrapping;
	activateHandle.
	self
		should: [handle activeTestWrap]
		raise: MessageNotUnderstood! !

HandleClassTest subclass: #HandleStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateHandleDontChangeOrigineNonQuick
	| trueObject handle |
	trueObject :=  (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass)..
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	handle inst1: 'test'.
	self deny: trueObject nQInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateHandleDontChangeOrigineQuick
	| trueObject handle |
	trueObject :=  (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass)..
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	handle inst1: 'test'.
	self deny: trueObject qInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateHandleNonQuick
	| trueObject handle |
	trueObject := self testClass new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.
	handle inst1: 'test'.
	self assert: handle nQInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateHandleQuick
	| trueObject handle |
	trueObject := self testClass new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.
	handle inst1: 'test'.
	self assert: handle qInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateOrigineButNotHandleNonQuick
	| trueObject handle |
	trueObject := (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	trueObject inst1: 'test'.
	self deny: handle nQInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:30'!
testChangingStateOrigineButNotHandleQuick
	| trueObject handle |
	trueObject := (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	trueObject inst1: 'test'.
	self deny: handle qInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:29'!
testChangingStateOrigineNonQuick
	| trueObject handle |
	trueObject := (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	trueObject inst1: 'test'.
	self assert: trueObject nQInst1 = 'test'! !

!HandleStateTest methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:30'!
testChangingStateOrigineQuick
	| trueObject handle |
	trueObject := (self testClass) new.
	handle := self handleClass initializeFor: trueObject to: (self testClass).
	handle dontUseShadowBehavior; useHandleState; activateHandle.

	trueObject inst1: 'test'.
	self assert: trueObject qInst1 = 'test'! !

TestCase subclass: #HandleCriticalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

HandleCriticalTest subclass: #HArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HArrayTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:39'!
objectToTest
	^Array new: 1.! !

HandleCriticalTest subclass: #HBitmapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HBitmapTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:39'!
objectToTest
	^ Bitmap new.! !

HandleCriticalTest subclass: #HBlockContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HBlockContextTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:41'!
objectToTest
	! !

HandleCriticalTest subclass: #HByteArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HByteArrayTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:42'!
objectToTest
	^ByteArray new.! !

HandleCriticalTest subclass: #HByteStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HByteStringTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:42'!
objectToTest
	^ByteString new.! !

HandleCriticalTest subclass: #HCharacterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HCharacterTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:42'!
objectToTest
	^#d! !

HandleCriticalTest subclass: #HCompileMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HCompileMethodTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:43'!
objectToTest
	^HCompileMethodTest>>#objectToTest! !

HandleCriticalTest subclass: #HDisplayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HDisplayTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:45'!
objectToTest
	^Display.! !

HandleCriticalTest subclass: #HFloatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HFloatTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:45'!
objectToTest
	^Float new.! !

HandleCriticalTest subclass: #HLargePositiveIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HLargePositiveIntegerTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:46'!
objectToTest
	^LargePositiveInteger new.! !

HandleCriticalTest subclass: #HMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HMessageTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:47'!
objectToTest
	^Message selector: #objectToTest.! !

HandleCriticalTest subclass: #HMethodContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HMethodContextTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:47'!
objectToTest
	! !

HandleCriticalTest subclass: #HPointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HPointTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:49'!
objectToTest
	^1@1! !

HandleCriticalTest subclass: #HProcessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HProcessTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:51'!
objectToTest
	^Process new! !

HandleCriticalTest subclass: #HSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HSmallIntegerTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:52'!
objectToTest
	^1! !

HandleCriticalTest subclass: #HSmalltalkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-CriticalTests'!

!HSmalltalkTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:53'!
objectToTest
	^Smalltalk! !

!HandleCriticalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:19'!
handleClass
	^SCHandle! !

!HandleCriticalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:25'!
objectToTest
	^self subclassResponcability! !

!HandleCriticalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:17'!
testCreateHandle
	self shouldnt: [self handleClass for: (self objectToTest)] raise: Exception.! !

!HandleCriticalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 14:22'!
testPrintString
	self shouldnt: [(self handleClass for: (self objectToTest)) printString] raise: Exception.! !

TestCase subclass: #MirrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testLookupReadSend
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) lookupReadSend = 'success'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testMirrorOverLookSend
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) mirrorOverLookSend = 'success'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testMirrorOverSuperSend
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) mirrorOverSuperSend = 'success'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testMirrorSend
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) mirrorSend = 'mirror'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testOverload
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) toOverLoad = 'success'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testReadAccess
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) readAccess = 'success'! !

!MirrorTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testSuperReadSend
	self assert: (MirrorHandleTest mirrorFor: MirrorHandleSubClassTest new) superReadSend = 'success'! !

TestCase subclass: #PrimitivesHijackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!PrimitivesHijackTest methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:52'!
testPrimitiveInstVarAt

 | ha a |
a := A new.
ha := (self handleClass for: a to: A).
self assert: ((ha instVarAt: 1) = (a instVarAt: 1)).


! !

TestCase subclass: #PrimitivesScopeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Kernel'!

!PrimitivesScopeTest methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
testBeeper
	self
		should: [MyBeeper primitiveBeep]
		raise: MessageNotUnderstood.
	self
		shouldnt: [(PrimitivesScope mirrorFor: MyBeeper) primitiveBeep]
		raise: MessageNotUnderstood! !

TestCase subclass: #PropagationFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 14:05'!
testWrapFooBar
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableFooBar) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableFooBar) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 14:01'!
testWrapFooBarNotQuick
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableFooBarNotQuick) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableFooBarNotQuick) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/19/2011 15:49'!
testWrapFooBarState
	self assert: (((HandleTestWrapToBarClass stateFor: (Foo new)) instanceVariableFooBar) isBar).
	self deny: (((HandleTestWrapToBarClass stateFor: (Foo new)) instanceVariableFooBar) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/19/2011 18:04'!
testWrapInteger
	self should: [((HandleTestWrapToBarClass for: (Foo new)) instanceVariableInteger) isBar] raise: MessageNotUnderstood.
	self should: [((HandleTestWrapToBarClass for: (Foo new)) instanceVariableInteger) isFoo] raise: MessageNotUnderstood.
	! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/19/2011 18:06'!
testWrapIntegerNotQuick
	self should: [(((HandleTestWrapToBarClass for: (Foo new)) instanceVariableIntegerNotQuick) isBar)] raise: MessageNotUnderstood.
		self should: [(((HandleTestWrapToBarClass for: (Foo new)) instanceVariableIntegerNotQuick) isFoo)] raise: MessageNotUnderstood.
	! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 14:06'!
testWrapObject
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableObject) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableObject) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 14:00'!
testWrapObjectNotQuick
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableObjectNotQuick) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableObjectNotQuick) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 14:06'!
testWrapString
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableString) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableString) isFoo).! !

!PropagationFunctionalTest methodsFor: 'Nostate' stamp: 'jb 1/14/2011 13:58'!
testWrapStringNotQuick
	self assert: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableStringNotQuick) isBar).
	self deny: (((HandleTestWrapToBarClass for: (Foo new)) instanceVariableStringNotQuick) isFoo).! !

TestCase subclass: #RevocablesObjectsReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 2/4/2011 14:30'!
testGrantAccess

| a meta target |
a := RevocableObjectReference for: (Object new).
meta := a at:1.
target := a at:2.
self shouldnt:[target printString.] raise: AccessRevoqued.! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 4/5/2011 17:18'!
testRevoqueAccess

| a meta target |
a := RevocableObjectReference for: (Object new).
meta := a at:1.
target := a at:2.
meta revoke.
self should:[target printString.] raise: AccessRevoqued.! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 4/5/2011 17:30'!
testRevoqueAccessThenReenable

| a meta target |
a := RevocableObjectReference for: (Object new).
meta := a at:1.
target := a at:2.
meta revoke.
self should:[target printString.] raise: AccessRevoqued.
meta grant.
self shouldnt:[target printString.] raise: AccessRevoqued.
! !

!RevocablesObjectsReferenceTest methodsFor: 'feature' stamp: 'jb 4/5/2011 17:18'!
testRevoqueAllAccessToAObject: aClass

	| selectors a meta target |
	a := RevocableObjectReference for: (aClass new).
	meta := a at:1.
	target := a at:2.
	meta revoke.
	
	aClass methodDict do: [:each | self should: [(Message selector: each selector
										arguments: ((1 to: each numArgs) asArray)) sendTo: target] raise: AccessRevoqued].
	
	! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 2/4/2011 14:26'!
testRevoqueAllAccessToAObjectCollection

	self testRevoqueAllAccessToAObject: Collection.
	! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 2/4/2011 14:26'!
testRevoqueAllAccessToAObjectMorph

	self testRevoqueAllAccessToAObject: Morph.
	! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 2/4/2011 14:26'!
testRevoqueAllAccessToAObjectObject

	self testRevoqueAllAccessToAObject: Object.
	! !

!RevocablesObjectsReferenceTest methodsFor: 'tests' stamp: 'jb 4/5/2011 17:19'!
testRevoqueAllAccessToAObjectSmalltalk

	| selectors a meta target |
	a := RevocableObjectReference for: (Smalltalk).
	meta := a at:1.
	target := a at:2.
	meta revoke.
	(Smalltalk class) methodDict do: [:each | self should: [(Message selector: each selector
										arguments: ((1 to: each numArgs) asArray)) sendTo: target] raise: AccessRevoqued].
	
	! !

TestCase subclass: #RevocablesObjectsReferenceWithPropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Security'!

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testGrantAccess

| a meta target |
a := ControllerFactory for: (Object new).
meta := a at:1.
target := a at:2.
self shouldnt:[target printString.] raise: AccessRevoqued.! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testOneDontRevoqueTwo
| a meta target test a2 meta2 target2 |
	a := ControllerFactory for: (FooBar new).
	meta := a at:1.
	target := a at:2.

	a2 := ControllerFactory for: (FooBar new).
	meta2 := a2 at:1.
	target2 := a2 at:2.

	meta revoke.
	self shouldnt:[target2 printString.] raise: AccessRevoqued.

! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testRevoqueAccess

| a meta target |
a := ControllerFactory for: (Object new).
meta := a at:1.
target := a at:2.
meta revoke.
self should:[target printString.] raise: AccessRevoqued.! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testRevoqueAccessThenReenable

| a meta target |
a := ControllerFactory for: (Object new).
meta := a at:1.
target := a at:2.
meta revoke.
self should:[target printString.] raise: AccessRevoqued.
meta grant.
self shouldnt:[target printString.] raise: AccessRevoqued.
! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'feature' stamp: 'jb 4/5/2011 17:19'!
testRevoqueAllAccessToAObject: aClass

	| selectors a meta target |
	a := RevocableObjectReference for: (aClass new).
	meta := a at:1.
	target := a at:2.
	meta revoke.
	
	aClass methodDict do: [:each | self should: [(Message selector: each selector
										arguments: ((1 to: each numArgs) asArray)) sendTo: target] raise: AccessRevoqued].
	
	! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 2/7/2011 13:22'!
testRevoqueAllAccessToAObjectCollection

	self testRevoqueAllAccessToAObject: Collection.
	! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 2/7/2011 13:22'!
testRevoqueAllAccessToAObjectMorph

	self testRevoqueAllAccessToAObject: Morph.
	! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 2/7/2011 13:22'!
testRevoqueAllAccessToAObjectObject

	self testRevoqueAllAccessToAObject: Object.
	! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testRevoqueAllAccessToAObjectSmalltalk

	| selectors a meta target |
	a := ControllerFactory for: (Smalltalk).
	meta := a at:1.
	target := a at:2.
	meta revoke.
	(Smalltalk class) methodDict do: [:each | self should: [(Message selector: each selector
										arguments: ((1 to: each numArgs) asArray)) sendTo: target] raise: AccessRevoqued].
	
	! !

!RevocablesObjectsReferenceWithPropagationTest methodsFor: 'tests' stamp: 'jb 4/6/2011 09:52'!
testRevoqueAllObjectGraph
	| a meta target test |
a := ControllerFactory for: (FooBar new).
meta := a at:1.
target := a at:2.
test := target instanceVariableObject.

meta revoke.
self should:[test printString.] raise: AccessRevoqued.

meta grant.
self shouldnt:[test printString.] raise: AccessRevoqued.


! !

TestCase subclass: #TransactionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Transaction'!

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/9/2011 15:41'!
testAddMethod
| aB |
aB := [:e || ast cm |
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: e parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: e.
	e addSelectorSilently: #answer withMethod: cm.].
self assert: (BlockTransaction createTransaction: aB withReferences: {Object} andSanityCheck: [:e | e new answer = 42]).

! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/9/2011 15:58'!
testAddMethodDontChangeOriginal
| aB |
aB := [:e || ast cm |
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: e parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: e.
	e addSelectorSilently: #answer withMethod: cm.].
 	BlockTransaction createTransaction: aB withReferences: {Object} andSanityCheck: [:e | e lookupSelector: #answer].
	self deny: (Object lookupSelector: #answer) isNotNil.
! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/7/2011 15:37'!
testCommitChange
	| test ht| 	
	test := HandleTestClass new.
	ht := SCHandle for: (test).
	ht inst1: 1.
	ht inst2: 2.
	ht inst3: 3.
	ht at: 1 put: 4.
	ht at: 2 put: 5.
	ht at: 3 put: 6.
	
	self deny: (test nQInst1 = 1).
	self deny: (test qInst1 = 1).
	self deny: (test inst2 = 2).
	self deny: (test inst3 = 3).
	self deny: ((test at: 1) = 4).
	self deny: ((test at: 2) = 5).
	self deny: ((test at: 3) = 6).
	self deny: (test nQInst1 = ht nQInst1).
	ht commitChange.
	self assert: (test nQInst1 = 1).
	self assert: (test qInst1 = 1).
	self assert: (test inst2 = 2).
	self assert: (test inst3 = 3).
	self assert: ((test at: 1) = 4).
	self assert: ((test at: 2) = 5).
	self assert: ((test at: 3) = 6).
	
	! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/9/2011 15:47'!
testMethodAddedCanBeSend
| aB |
aB := [:e || ast cm |
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: e parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: e.
	e addSelectorSilently: #answer withMethod: cm.].
self assert: (BlockTransaction createTransaction: aB withReferences: {Object} andSanityCheck: [:e | e new answer = 42]).

! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/9/2011 15:47'!
testMethodAddedCanBeSendIndexed
| aB |
aB := [:e || ast cm |
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: e parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: e.
	e addSelectorSilently: #answer withMethod: cm.].
self assert: (BlockTransaction createTransaction: aB withReferences: {HandleTestClass} andSanityCheck: [:e | e new answer = 42]).

! !

!TransactionalTest methodsFor: 'propagation' stamp: 'jb 11/10/2011 17:10'!
testPropagationMethod
| aB |
aB := [:e || ast cm |
	ast := RBParser parseMethod: 'answer 1 + 2. ^42'.
	OCASTClosureAnalyzer new visitNode: ast.
	OCASTSemanticAnalyzer new
		scope: e superclass parseScope;
		visitNode: ast.
	cm := ast ir compiledMethod.
	cm methodClass: e.
	e addSelectorSilently: #answer withMethod: cm.].
self assert: (BlockTransaction createTransaction: aB withReferences: {HandleTestClass} andSanityCheck: [:e | e superclass new answer = 42]).! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/4/2011 15:07'!
testRemoveMethod
| aB |
aB := [:e | e methodDict removeKey: #notNil.].
BlockTransaction createTransaction: aB withReferences: {Object} andSanityCheck: [:e | self should: [e new notNil] raise: MessageNotUnderstood ]

! !

!TransactionalTest methodsFor: 'as yet unclassified' stamp: 'jb 11/4/2011 15:08'!
testRemoveMethodDontChangeOriginal
| aB |
aB := [:e | e methodDict removeKey: #notNil.].
BlockTransaction createTransaction: aB withReferences: {Object}.
self shouldnt: [Object new notNil] raise: MessageNotUnderstood.! !

Object subclass: #BenchmarkSuperClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Benchmark'!

BenchmarkSuperClass subclass: #BenchmarkClass
	instanceVariableNames: 'InstVar1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Benchmark'!

!BenchmarkClass methodsFor: 'as yet unclassified' stamp: 'jb 3/31/2011 16:14'!
getInstanceVar
	1 + 1.
	^InstVar1! !

!BenchmarkClass methodsFor: 'as yet unclassified' stamp: 'jb 3/31/2011 16:14'!
getInstanceVarPrim
	^InstVar1! !

!BenchmarkClass methodsFor: 'as yet unclassified' stamp: 'jb 3/31/2011 16:36'!
initialize
	InstVar1 := Object new.! !

Object subclass: #BlockTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-TransactionnalMemoryCWIP'!

!BlockTransaction class methodsFor: 'as yet unclassified' stamp: 'jb 11/4/2011 13:00'!
createTransaction: aBlock withReferences: anArray
| array return |
array := anArray collect: [:e | TransactionalHandle for: e].
^aBlock valueWithArguments: array.! !

!BlockTransaction class methodsFor: 'as yet unclassified' stamp: 'jb 11/4/2011 13:32'!
createTransaction: aBlock withReferences: anArray andSanityCheck: anotherBlock
| array return |
array := anArray collect: [:e | TransactionalHandle for: e].
return := aBlock valueWithArguments: array.
^anotherBlock valueWithArguments: array.! !

Object subclass: #HFactory
	instanceVariableNames: 'handleClass managerClass managers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-FactoryPattern'!

HFactory subclass: #ControllerFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-Revocables'!

!ControllerFactory class methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 17:03'!
createRevocableHandle
	| class  |
	class := (Metaclass new 
	setFormat: (RevocableObjectReferencePropagation class format);    	
	superclass: RevocableObjectReferencePropagation class;               
	methodDict: (MethodDictionary new);
	new).
	class setName: 'RevocableObjectReferenceWithPropagation'.
	class setFormat: (RevocableObjectReferencePropagation format).
	class superclass: RevocableObjectReferencePropagation.
	class methodDict: (MethodDictionary new).
	^class 

	


! !

!ControllerFactory class methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 17:29'!
for: anObject
	| handle factory handleClass |
	factory := self new.
	handleClass := self createRevocableHandle.
	factory handleClass: handleClass.
	handleClass factory: factory.
	handle := handleClass initializeFor: anObject.
	factory addToControllers: (RevocableControler for: handle).
	handle dontUseShadowBehavior;dontUseState;propagate.
	handle activateHandle.
	^{factory.handle}
	
! !

!ControllerFactory methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 17:29'!
addToControllers: aHandle
	controllers add: aHandle.! !

!ControllerFactory methodsFor: 'public' stamp: 'jb 4/5/2011 17:27'!
for: anObject 
	|handle |
	handle := handleClass initializeFor: anObject.
	controllers add: (RevocableControler for: handle).
	handle dontUseShadowBehavior;dontUseState;propagate.
	handle activateHandle.
	^handle.! !

!ControllerFactory methodsFor: 'public' stamp: 'jb 4/5/2011 17:26'!
grant
	controllers do: [:each | each grant].
	^'all access is now grant'! !

!ControllerFactory methodsFor: 'as yet unclassified' stamp: 'jb 3/14/2011 13:47'!
printString
	^'a RevocableControler'! !

!ControllerFactory methodsFor: 'public' stamp: 'jb 4/5/2011 17:27'!
revoke
	controllers do: [:each | each revoke].
	^'all access is revoque'! !

!ControllerFactory methodsFor: 'public' stamp: 'jb 4/5/2011 17:26'!
uninstall
	self flag: 'toDo'.
	controllers size timesRepeat: [ 
		controllers removeFirst uninstall.
		].	
	^'All controle is release'! !

!HFactory class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:16'!
createHandleSubclassOf: aClass
	| class  |
	
	class := (Metaclass new 
	setFormat: (aClass class format);    	
	superclass: aClass class;               
	methodDict: (MethodDictionary new);
	new).
	class setName: aClass printString.
	class setFormat: (aClass format).
	class superclass: aClass.
	class methodDict: (MethodDictionary new).
	^class 

	


! !

!HFactory class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:20'!
for: anObject
	| handle factory handleClass |
	
	factory := self new.
	handleClass := self createHandleSubclassOf: (self handleClassToUse).
	factory handleClass: handleClass.
	handleClass factory: factory.
	
	"first case"
	handle := handleClass initializeFor: anObject.
	factory addToControllers: (factory managerClass for: handle).
	handle dontUseShadowBehavior;dontUseState;propagate.
	handle activateHandle.
	^{factory.handle}
	
! !

!HFactory class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:18'!
handleClassToUse
	^self subclassResponcability
	! !

!HFactory methodsFor: 'interface' stamp: 'jb 11/14/2011 15:02'!
for: anObject 
	|handle |
	handle := handleClass initializeFor: anObject.
	managers add: (managerClass for: handle).
	handle activateHandle.
	^handle.! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 14:57'!
handleClass

	^ handleClass! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 14:57'!
handleClass: anObject

	handleClass := anObject! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 15:28'!
initialize
	super initialize.
	managers := OrderedCollection new.! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 15:00'!
managerClass

	^ managerClass! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 15:00'!
managerClass: anObject

	managerClass := anObject! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 15:00'!
managers

	^ managers! !

!HFactory methodsFor: 'accessing' stamp: 'jb 11/14/2011 15:00'!
managers: anObject

	managers := anObject! !

HFactory subclass: #SCTransactionalFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone-Experimentation'!

!SCTransactionalFactory class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:25'!
for: anObject
	| handle factory handleClass |
	
	factory := self new.
	handleClass := self createHandleSubclassOf: (self handleClassToUse).
	factory handleClass: handleClass.
	handleClass factory: factory.
	
	"first case"
	handle := handleClass initializeFor: anObject.
	factory addToControllers: handle.
	handle activateHandle.
	^{factory.handle}
	
! !

!SCTransactionalFactory class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:21'!
handleClassToUse
	^SCTransactionalUsingFactoryHandle! !

!SCTransactionalFactory methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:27'!
addToControllers: aHandle
	managers add: aHandle.! !

!SCTransactionalFactory methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:35'!
checkIfExist: anObject
	managers do:[:e | anObject == e ifTrue: [^e]].
	^nil! !

!SCTransactionalFactory methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:32'!
for: anObject 
	|handle return |
	return := self checkIfExist: anObject.
	return ifNil: [
		handle := handleClass initializeFor: anObject.
		self addToControllers: handle.
		handle activateHandle.
		^handle.].
	^return
	! !

Object subclass: #Handle
	instanceVariableNames: 'receiver classLookup state indexedField configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Core'!

Handle subclass: #AbstractMirrorHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ApplicationMirrorAPI'!

!AbstractMirrorHandle class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:28'!
changeStaticHierarchy: aMethodDict to: aClass 
aMethodDict
		do: [:each | each methodClass: aClass].
	^ methodDict ! !

!AbstractMirrorHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:53'!
debugMirrorFor: anObject 
	| handle aShadowClass | 
	aShadowClass := self reflect: anObject.
	handle := self initializeFor: anObject to: aShadowClass.
	handle dontUseState; useShadowBehavior.
	^ handle! !

!AbstractMirrorHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:58'!
mirrorFor: anObject 
	| aShadowClass handle |
	aShadowClass := self reflect: anObject.
	handle := self initializeFor: anObject to: aShadowClass.
	handle dontUseState; useShadowBehavior; activateHandle. 
	^ handle! !

!AbstractMirrorHandle class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:28'!
reflect: aObject
	| aBehavior  aMethodDict |
	aMethodDict  := aObject class methodDict copy.
	aMethodDict
		addAll: (self changeStaticHierarchy: self methodDict copy to: aObject class).
	aBehavior := Behavior new setFormat: aObject class format;
				 superclass: aObject class superclass;
				 methodDict: aMethodDict.
	aBehavior superclass: aObject class.
	^ aBehavior! !

AbstractMirrorHandle subclass: #PrimitivesScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ApplicationMirrorAPI'!

Handle subclass: #BenchHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Benchmark'!

!BenchHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/31/2011 17:32'!
propagateTo: anObject
	^anObject! !

!BenchHandle methodsFor: 'as yet unclassified' stamp: 'jb 3/31/2011 17:26'!
initialize
	super initialize.
	self propagate.! !

Handle subclass: #ClassHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

!ClassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 9/26/2011 15:46'!
InitializeForClass: aClassClass
	| aHandle meta class hclass |
	aClassClass isLiteral
		ifTrue: [^ 'nope'].
			
	
	hclass := MetaclassHandle initializeFor: (aClassClass class).
	aHandle := self initializeFor: aClassClass to: hclass. 
	aHandle useHandleState.
	aHandle useShadowBehavior.
	^aHandle! !

!ClassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 2/7/2011 15:14'!
createMetaclass
	^MetaclassHandle new.! !

!ClassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 9/28/2011 18:45'!
for: aClass 
	| aHandle meta class hclass |
	aClass isLiteral
		ifTrue: [^ 'nope'].
	
	
	hclass := ClassHandle InitializeForClass: (aClass class).
	
	aHandle := self initializeFor: aClass to: hclass.
	aHandle useHandleState.
	aHandle useShadowBehavior.
	
	"meta"
	aHandle classLookup classLookup activateHandle.
	"class"
	aHandle classLookup activateHandle.
	"self"
	aHandle activateHandle.
	
	^aHandle! !

!ClassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 18:02'!
propagateTo: anObject
	^StateSCHandle for: anObject! !

!ClassHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:54'!
recreateClassHandle: anObject with: t2 
	| t3 |
	t3 := self initializeFor: anObject
	t3 useHandleState.
	t3 addInstanceVar: t2.
	t3 activateHandle.
	t3 compile: self methodClass.
	^ t3! !

!ClassHandle methodsFor: 'as yet unclassified' stamp: 'jb 7/22/2011 10:54'!
copyStateOfObject: anObject

	| size |
	size := anObject class allInstVarNames size.
	state := Array new: size.
	1
		to: size
		do: [:index | state
				at: index
				put: (anObject instVarAt: index) copy]! !

!Handle class methodsFor: 'instance creation' stamp: 'jb 7/26/2011 12:26'!
createHandle
	^ self basicNew handleInit! !

!Handle class methodsFor: 'private' stamp: 'jb 5/31/2011 15:00'!
for: anObject 
	| handle |
	handle := self initializeFor: anObject.
	handle activateHandle.
	^ handle! !

!Handle class methodsFor: 'private' stamp: 'jb 9/29/2011 15:45'!
for: anObject to: aShadowClass 
	| handle |
	handle := self initializeFor: anObject to: aShadowClass.
	handle activateHandle.
	^ handle! !

!Handle class methodsFor: 'private' stamp: 'bj 3/30/2011 09:49'!
initializeFor: anObject
	| handle |
	handle := self createHandle.
	handle receiver: anObject.
	handle useHandleState.
	^ handle! !

!Handle class methodsFor: 'private' stamp: 'jb 10/4/2011 16:42'!
initializeFor: anObject to: aShadowClass
	| handle |
	handle := self createHandle.
	handle initializeHandleWith: anObject to: aShadowClass.
	handle useShadowBehavior.
	handle useHandleState.
	^ handle! !

!Handle class methodsFor: 'propagation' stamp: 'jb 1/19/2011 16:38'!
propagateTo: aObject
	^aObject! !

!Handle methodsFor: 'activating' stamp: 'jb 8/4/2011 23:09'!
activateHandle
	<primitive: 549>
	^ self primitiveFailed! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 11:16'!
activateSelfRepresentHandleAndActivateReturnWrapping
	
	configuration := configuration bitOr: 4.! !

!Handle methodsFor: 'activating' stamp: 'jb 5/10/2011 11:50'!
becomeHandle
	<primitive: 549>
	^ self primitiveFailed! !

!Handle methodsFor: 'accessing' stamp: 'JB 12/2/2010 15:07'!
classLookup
	^ classLookup! !

!Handle methodsFor: 'accessing' stamp: 'JB 12/2/2010 15:07'!
classLookup: aClass 
	classLookup := aClass! !

!Handle methodsFor: 'accessing' stamp: 'JB 12/2/2010 15:07'!
configuration
	^ configuration! !

!Handle methodsFor: 'initialize-release' stamp: 'jb 10/5/2011 16:40'!
copyStateOfObject: anObject
	| size indSize |
	"size of state"
	size := anObject class allInstVarNames size.
	"copy state"
	state := Array new: size.
	1 to: size do: [:index | state
				at: index
				put: (anObject instVarAt: index)].
			
	"size of indexed field "
	indSize := anObject basicSize.
	"copy indexed field if needed"
	
	(indSize > 0) ifTrue: [
		indexedField := Array new: indSize.
		1 to: indSize do: [:index | indexedField
				at: index
				put: (anObject basicAt: index)]].! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 11:16'!
desactivateSelfRepresentHandleAndActivateReturnWrapping
	configuration := configuration bitAnd: 11.! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 11:08'!
doNotPropagation
	configuration := configuration bitAnd: 7.! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 11:10'!
dontUseShadowBehavior
	configuration := configuration bitAnd: 13! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 11:02'!
dontUseState
	configuration := configuration bitAnd: 14! !

!Handle methodsFor: 'initialize-release' stamp: 'jb 7/26/2011 13:20'!
handleInit
	configuration := 0.
	self dontUseShadowBehavior.
	self dontUseState.
	self doNotPropagation.
	self activateSelfRepresentHandleAndActivateReturnWrapping.! !

!Handle methodsFor: 'initialize-release' stamp: 'jb 7/28/2011 16:10'!
initialize
	receiver initialize.
	self handleInit.
	self useShadowBehavior.
	self activateHandle.! !

!Handle methodsFor: 'initialize-release' stamp: 'jb 5/31/2011 14:55'!
initializeHandleWith: aObject to: aClass 
	| size |
	receiver := aObject.
	classLookup := aClass.! !

!Handle methodsFor: 'testing' stamp: 'JB 12/2/2010 15:07'!
isHandler
	^ true! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 10:52'!
propagate
	configuration := configuration bitOr: 8! !

!Handle methodsFor: 'accessing' stamp: 'JB 12/2/2010 15:07'!
receiver
	^ receiver! !

!Handle methodsFor: 'accessing' stamp: 'JB 12/2/2010 15:07'!
receiver: aObject 
	receiver := aObject! !

!Handle methodsFor: 'option' stamp: 'jb 5/31/2011 14:55'!
useHandleState
	configuration := configuration bitOr: 1.
	self copyStateOfObject: receiver.
	! !

!Handle methodsFor: 'option' stamp: 'bj 3/28/2011 10:43'!
useShadowBehavior
	self classLookup
		ifNil: [^ Error signal: 'classLookup  isNil you want to crash the VM ?'].
	configuration := configuration bitOr: 2! !

!Handle methodsFor: 'option' stamp: 'jb 9/28/2011 13:18'!
useState
	configuration := configuration bitOr: 1.
	state ifNil:[ 
		self copyStateOfObject: receiver.].! !

Handle subclass: #HandleTestWrapToBarClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-HandlesClasses'!

!HandleTestWrapToBarClass class methodsFor: 'as yet unclassified' stamp: 'jb 1/14/2011 13:37'!
for: aObject
	^self for: aObject to: Bar! !

!HandleTestWrapToBarClass class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:56'!
for: aObject to: aClass 
	| handle |
	handle := self initializeFor: aObject to: aClass.
	handle useShadowBehavior.
	handle propagate.
	handle dontUseState.
	handle activateHandle.
	^ handle! !

!HandleTestWrapToBarClass class methodsFor: 'as yet unclassified' stamp: 'jb 1/19/2011 16:34'!
propagateTo: aObject
	^HandleTestWrapToBarClass for: aObject.! !

!HandleTestWrapToBarClass class methodsFor: 'as yet unclassified' stamp: 'jb 1/19/2011 15:55'!
stateFor: aObject
	^self stateFor: aObject to: Bar! !

!HandleTestWrapToBarClass class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:56'!
stateFor: aObject to: aClass 
	| handle |
	handle := self initializeFor: aObject to: aClass.
	handle useShadowBehavior.
	handle propagate.
	handle useHandleState.
	handle activateHandle.
	^ handle! !

Handle subclass: #LimitedInterfaceHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-LimitedInterface'!

LimitedInterfaceHandle subclass: #CategoryHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-LimitedInterface'!

!CategoryHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 10:08'!
for: anObject categories: aCollectionOfSymbol
	
	| collectedSymbol |
	collectedSymbol := (anObject class methodDict collect: [:each | each category] thenSelect:[:each | aCollectionOfSymbol includes: each]) keys.
	^super for: anObject with: collectedSymbol.! !

!CategoryHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:27'!
for: anObject category: aSymbol
	^self for: anObject categories: #(aSymbol).! !

CategoryHandle subclass: #PublicHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-LimitedInterface'!

!PublicHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:39'!
for: anObject
	^super for: anObject category: #public.! !

!PublicHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:39'!
for: anObject category: something
	^self shouldNotImplement.! !

!LimitedInterfaceHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:48'!
for: anObject with: aCollectionOfSymbol
	| freshHandle |
	freshHandle := self initializeFor: anObject with: aCollectionOfSymbol.
	freshHandle activateHandle.
	^ freshHandle! !

!LimitedInterfaceHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/28/2011 10:45'!
initializeFor: anObject to: aCollectionOfSymbols 
	self shouldNotImplement! !

!LimitedInterfaceHandle class methodsFor: 'as yet unclassified' stamp: 'bj 3/26/2011 16:18'!
initializeFor: anObject with: aCollectionOfSymbols 
	| newClass freshHandle |
	
	freshHandle := self createHandle.
	newClass := freshHandle createLimitedClassFor: anObject withMethods: aCollectionOfSymbols.
	
	freshHandle initializeHandleWith: anObject to: newClass.	
	freshHandle desactivateSelfRepresentHandleAndActivateReturnWrapping.
	freshHandle useShadowBehavior.
	^ freshHandle! !

!LimitedInterfaceHandle methodsFor: 'as yet unclassified' stamp: 'jb 4/6/2011 10:30'!
createLimitedClassFor: anObject withMethods: aCollectionOfSymbols
	| newMethodDict |
	
	newMethodDict := MethodDictionary new.
	aCollectionOfSymbols
		do: [:index | newMethodDict at: index put: (anObject class methodDict at: index)].
	
	^ Behavior new setFormat: anObject class format;
		 superclass: anObject class superclass;
		 methodDict: newMethodDict! !

LimitedInterfaceHandle subclass: #PragmaHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-LimitedInterface'!

!PragmaHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:44'!
for: anObject pragma: aSymbol
	^self for: anObject pragmas: #(aSymbol).! !

!PragmaHandle class methodsFor: 'as yet unclassified' stamp: 'jb 3/8/2011 11:46'!
for: anObject pragmas: aCollectionOfSymbol
	| collectedSymbol |
	collectedSymbol := (anObject class methodDict collect: [:each | each pragmas] thenSelect:[:each | aCollectionOfSymbol includes: each]) keys.
	^super for: anObject with: collectedSymbol.! !

Handle subclass: #MetaHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Core'!

!MetaHandle class methodsFor: 'accessing' stamp: 'jb 1/14/2011 11:21'!
for: aHandle
	^ self for: aHandle to: self! !

!MetaHandle methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 10:11'!
changeShadowClassTo: aShadowClass
	super classLookup: aShadowClass.! !

!MetaHandle methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 10:12'!
classLookup: aShadowClass
	1 halt.! !

!MetaHandle methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
initialize
	super initialize! !

!MetaHandle methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
isMeta
	^ true! !

MetaHandle subclass: #MetaTransactionnal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-TransactionnalMemoryCWIP'!

!MetaTransactionnal class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
installState
	^ self! !

MetaHandle subclass: #MetaWatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Watcher'!

!MetaWatcher methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
isMeta
	^ true! !

!MetaWatcher methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
unWatch
	self receiver become: self! !

MetaHandle subclass: #RevocableControler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-Revocables'!

!RevocableControler methodsFor: 'as yet unclassified' stamp: 'bj 3/28/2011 11:12'!
grant
	self dontUseShadowBehavior.! !

!RevocableControler methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 17:25'!
revoke
	self useShadowBehavior.! !

!RevocableControler methodsFor: 'as yet unclassified' stamp: 'jb 3/14/2011 14:10'!
uninstall

	self flag: 'toDo'.
	self becomeForward: receiver.! !

Handle subclass: #MetaclassHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

!MetaclassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 7/21/2011 15:19'!
for: aClass 
	^(self initializeFor: aClass) activateHandle.! !

!MetaclassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 7/21/2011 15:36'!
initializeFor: aClass 
	| aHandle meta class hclass hMetaclassClass |
	aClass isLiteral
		ifTrue: [^ 'nope'].

	self assert: (aClass = Metaclass).
	hMetaclassClass := self initializeForClass: (aClass class).
	
	aHandle := self initializeFor: aClass to: hMetaclassClass.
	aHandle useHandleState.
	hMetaclassClass classLookup: aHandle.
	hMetaclassClass useShadowBehavior.
	hMetaclassClass useHandleState.
	
	^aHandle! !

!MetaclassHandle class methodsFor: 'as yet unclassified' stamp: 'jb 7/21/2011 15:06'!
initializeForClass: aClass 
	^super initializeFor: aClass.! !

!MetaclassHandle methodsFor: 'as yet unclassified' stamp: 'jb 7/21/2011 15:37'!
activateHandle

	self classLookup trueActivation.
	self trueActivation! !

!MetaclassHandle methodsFor: 'as yet unclassified' stamp: 'jb 7/21/2011 15:18'!
trueActivation
	super activateHandle.! !

Handle subclass: #MetaclassSCHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone'!

!MetaclassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:41'!
for: aClass 
	^(self initializeFor: aClass) activateHandle.! !

!MetaclassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:41'!
initializeFor: aClass 
	| aHandle meta class hclass hMetaclassClass |
	aClass isLiteral
		ifTrue: [^ 'nope'].

	self assert: (aClass = Metaclass).
	hMetaclassClass := self initializeForClass: (aClass class).
	
	aHandle := self initializeFor: aClass to: hMetaclassClass.
	aHandle useHandleState.
	hMetaclassClass classLookup: aHandle.
	hMetaclassClass useShadowBehavior.
	hMetaclassClass useHandleState.
	
	^aHandle! !

!MetaclassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:41'!
initializeForClass: aClass 
	^super initializeFor: aClass.! !

!MetaclassSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:41'!
activateHandle

	self classLookup trueActivation.
	self trueActivation! !

!MetaclassSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:41'!
trueActivation
	super activateHandle.! !

Handle subclass: #ObjectHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

!ObjectHandle class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
debugFor: t1 to: t2 
	| t3 t4 t5 |
	t3 := self createHandle.
	t4 := ClassHandle for: t2.
	t3 initializeHandleWith: t1 to: t4.
	^ t3! !

Handle subclass: #RevocableObjectReference
	instanceVariableNames: ''
	classVariableNames: 'RevoqueClass'
	poolDictionaries: ''
	category: 'Handles-Security-Revocables'!

!RevocableObjectReference class methodsFor: 'as yet unclassified' stamp: 'jb 2/4/2011 17:17'!
compiledoesNotUnderstandHackOn: aClass
	aClass compile: 'doesNotUnderstand: aMessage
	^ AccessRevoqued signal.'! !

!RevocableObjectReference class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:56'!
for: anObject
	
	| handle meta |
	RevoqueClass ifNil: [self initializeRevoqueClass].
	handle := super initializeFor: anObject to: RevoqueClass.
	handle dontUseShadowBehavior;dontUseState;doNotPropagation.
	meta := RevocableControler for: handle.
	handle activateHandle.
	^{meta.handle}. ! !

!RevocableObjectReference class methodsFor: 'as yet unclassified' stamp: 'jb 2/4/2011 17:20'!
initializeRevoqueClass
	RevoqueClass := (Metaclass new 
	setFormat: (ProtoObject class format);    	"car on cree un sous-class sans instance variable"
	superclass: Class;               	"il faut respecte la hierarchie parallele"
	methodDict: (MethodDictionary new);
	new).
	RevoqueClass setName: 'RevoqueClass'.
	RevoqueClass setFormat: (Object format).
	RevoqueClass superclass: nil.
	RevoqueClass methodDict: (MethodDictionary new).
	self compiledoesNotUnderstandHackOn: RevoqueClass.! !

RevocableObjectReference subclass: #RevocableObjectReferencePropagation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Security-Revocables'!

RevocableObjectReferencePropagation class
	instanceVariableNames: 'factory'!

RevocableObjectReferencePropagation class
	instanceVariableNames: 'factory'!

!RevocableObjectReferencePropagation class methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 16:59'!
factory
	^factory! !

!RevocableObjectReferencePropagation class methodsFor: 'as yet unclassified' stamp: 'jb 4/5/2011 16:59'!
factory: aFactory
	factory := aFactory! !

!RevocableObjectReferencePropagation class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:57'!
initializeFor: aObject
	^ super initializeFor: aObject to: RevoqueClass.! !

!RevocableObjectReferencePropagation class methodsFor: 'as yet unclassified' stamp: 'jb 4/6/2011 09:47'!
propagateTo: anObject
		^(self factory) for: anObject.! !

!RevocableObjectReferencePropagation class methodsFor: 'as yet unclassified' stamp: 'jb 2/7/2011 13:29'!
revoqueClass
	^RevoqueClass! !

Handle subclass: #Watcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Watcher'!

Watcher subclass: #TranscriptWatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Watcher'!

!TranscriptWatcher class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
InitializeWatcherFor: aObject 
	| behavior treeRewriter |
	treeRewriter := RBParseTreeRewriter new.
	treeRewriter replaceMethod: self detectRule with: self replaceRule.
	behavior := Behavior new setFormat: aObject class format;
				 superclass: aObject class;
				 methodDict: MethodDictionary new.
	aObject class methodDict
		do: [:method | 
			| tree |
			tree := treeRewriter
						executeTree: (RBParser parseMethod: method getSource);
						 tree.
			behavior compile: tree formattedCode].
	^ behavior! !

!TranscriptWatcher class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
detectRule
	^ '`@methodName: `@methodArgs
     | `@Temps |
     `@Statements'! !

!TranscriptWatcher class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
replaceRule
	^ '`@methodName: `@methodArgs
     | `@Temps |
	Transcript show: ''message send '',[self `@methodName: `@methodArgs ] asString.
	Transcript cr.
	^super `@methodName: `@methodArgs.'! !

!Watcher class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
InitializeWatcherFor: aObject 
	^ aObject class! !

!Watcher class methodsFor: 'as yet unclassified' stamp: 'bj 3/30/2011 09:48'!
watch: aObject 
	| watcher aClass meta |
	watcher := self new.
	aClass := self InitializeWatcherFor: aObject.
	watcher become: aObject.
	meta := MetaWatcher for: aObject.
	aObject classLookup: aClass.
	aObject useShadowBehavior.
	aObject receiver: watcher.
	aObject activateHandle.
	^ meta! !

!Object methodsFor: '*handles' stamp: 'jb 11/7/2011 16:04'!
commitAllChange
	<primitive: 'primitiveCommitAllState'>
	self halt..! !

!Object methodsFor: '*handles' stamp: 'jb 11/7/2011 15:48'!
commitChange
	<primitive: 'primitiveCommitState'>
	self halt..! !

!Object methodsFor: '*handles' stamp: 'jb 10/11/2011 14:44'!
isHandle
	<primitive: 'primitiveIsHandle'>
	^self primitiveFailed.! !

Object subclass: #SCHandle
	instanceVariableNames: 'receiver classLookup clone configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone'!

SCHandle subclass: #ClassSCHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone'!

!ClassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:40'!
InitializeForClass: aClassClass
	| aHandle meta class hclass |
	aClassClass isLiteral
		ifTrue: [^ 'nope'].
			
	
	hclass := MetaclassHandle initializeFor: (aClassClass class).
	aHandle := self initializeFor: aClassClass to: hclass. 
	aHandle useHandleState.
	aHandle useShadowBehavior.
	^aHandle! !

!ClassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:40'!
createMetaclass
	^MetaclassHandle new.! !

!ClassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/14/2011 18:14'!
for: aClass 
	| aHandle meta class hclass |
	aClass isLiteral
		ifTrue: [^ 'nope'].
	
	
	hclass := self InitializeForClass: (aClass class).
	
	aHandle := self initializeFor: aClass to: hclass.
	aHandle useHandleState.
	aHandle useShadowBehavior.
	"aHandle propagate."
	
	"meta"
	aHandle classLookup classLookup activateHandle.
	"class"
	aHandle classLookup activateHandle.
	"self"
	aHandle activateHandle.
	
	^aHandle! !

!ClassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 18:17'!
propagateTo: anObject
	^StateSCHandle for: anObject! !

!ClassSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/10/2011 15:40'!
recreateClassHandle: anObject with: t2 
	| t3 |
	t3 := self initializeFor: anObject
	t3 useHandleState.
	t3 addInstanceVar: t2.
	t3 activateHandle.
	t3 compile: self methodClass.
	^ t3! !

!ClassSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/18/2011 16:13'!
copyStateOfObject: anObject
	clone :=  anObject shallowCopy.
	"take care about methodDict"
	clone methodDict: (clone methodDict shallowCopy).! !

SCHandle subclass: #MetaSCHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone'!

!MetaSCHandle class methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
for: aHandle
	^ self for: aHandle to: self! !

!MetaSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:22'!
changeShadowClassTo: aShadowClass
	super classLookup: aShadowClass.! !

!MetaSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:22'!
classLookup: aShadowClass
	1 halt.! !

!MetaSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:22'!
initialize
	super initialize! !

!MetaSCHandle methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:22'!
isMeta
	^ true! !

!SCHandle class methodsFor: 'instance creation' stamp: 'jb 10/7/2011 18:22'!
createHandle
	^ self basicNew handleInit! !

!SCHandle class methodsFor: 'private' stamp: 'jb 11/10/2011 16:02'!
for: anObject 
	| handle |
	handle := self initializeFor: anObject.
	handle activateHandle.
	^ handle! !

!SCHandle class methodsFor: 'private' stamp: 'jb 10/7/2011 18:22'!
for: anObject to: aShadowClass 
	| handle |
	handle := self initializeFor: anObject to: aShadowClass.
	handle activateHandle.
	^ handle! !

!SCHandle class methodsFor: 'private' stamp: 'jb 10/10/2011 13:11'!
initializeFor: anObject
	| handle |
	handle := self createHandle.
	handle receiver: anObject.
	handle classLookup: anObject class.
	handle useHandleState.
	^ handle! !

!SCHandle class methodsFor: 'private' stamp: 'jb 10/7/2011 18:22'!
initializeFor: anObject to: aShadowClass
	| handle |
	handle := self createHandle.
	handle initializeHandleWith: anObject to: aShadowClass.
	handle useShadowBehavior.
	handle useHandleState.
	^ handle! !

!SCHandle class methodsFor: 'propagation' stamp: 'jb 10/11/2011 15:59'!
propagateTo: aObject
	^aObject! !

!SCHandle class methodsFor: 'install' stamp: 'jb 10/7/2011 18:45'!
useSC
	(SmalltalkImage current specialObjectsArray at: 57 put: self).! !

!SCHandle methodsFor: 'activating' stamp: 'jb 10/7/2011 18:22'!
activateHandle
	<primitive: 549>
	^ self primitiveFailed! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
activateSelfRepresentHandleAndActivateReturnWrapping
	
	configuration := configuration bitOr: 4.! !

!SCHandle methodsFor: 'activating' stamp: 'jb 10/7/2011 18:22'!
becomeHandle
	<primitive: 549>
	^ self primitiveFailed! !

!SCHandle methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
classLookup
	^ classLookup! !

!SCHandle methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
classLookup: aClass 
	classLookup := aClass! !

!SCHandle methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 4/24/2012 11:23'!
clone
	^clone! !

!SCHandle methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
configuration
	^ configuration! !

!SCHandle methodsFor: 'initialize-release' stamp: 'jb 10/7/2011 18:27'!
copyStateOfObject: anObject
	clone :=  anObject shallowCopy! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
desactivateSelfRepresentHandleAndActivateReturnWrapping
	configuration := configuration bitAnd: 11.! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
doNotPropagation
	configuration := configuration bitAnd: 7.! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
dontUseShadowBehavior
	configuration := configuration bitAnd: 13! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
dontUseState
	configuration := configuration bitAnd: 14! !

!SCHandle methodsFor: 'initialize-release' stamp: 'jb 10/7/2011 18:22'!
handleInit
	configuration := 0.
	self dontUseShadowBehavior.
	self dontUseState.
	self doNotPropagation.
	self activateSelfRepresentHandleAndActivateReturnWrapping.! !

!SCHandle methodsFor: 'initialize-release' stamp: 'jb 10/7/2011 18:22'!
initialize
	receiver initialize.
	self handleInit.
	self useShadowBehavior.
	self activateHandle.! !

!SCHandle methodsFor: 'initialize-release' stamp: 'jb 10/7/2011 18:22'!
initializeHandleWith: aObject to: aClass 
	| size |
	receiver := aObject.
	classLookup := aClass.! !

!SCHandle methodsFor: 'testing' stamp: 'jb 10/7/2011 18:22'!
isHandler
	^ true! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
propagate
	configuration := configuration bitOr: 8! !

!SCHandle methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
receiver
	^ receiver! !

!SCHandle methodsFor: 'accessing' stamp: 'jb 10/7/2011 18:22'!
receiver: aObject 
	receiver := aObject! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
useHandleState
	configuration := configuration bitOr: 1.
	self copyStateOfObject: receiver.
	! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
useShadowBehavior
	self classLookup
		ifNil: [^ Error signal: 'classLookup  isNil you want to crash the VM ?'].
	configuration := configuration bitOr: 2! !

!SCHandle methodsFor: 'option' stamp: 'jb 10/7/2011 18:22'!
useState
	configuration := configuration bitOr: 1.
	state ifNil:[ 
		self copyStateOfObject: receiver.].! !

SCHandle subclass: #SCPropagateHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone'!

SCPropagateHandle subclass: #CoolOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

!CoolOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 17:40'!
initializeFor: anObject
| handle |
	handle := super initializeFor: anObject.
	handle dontUseState.
	^ handle! !

!CoolOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 17:07'!
propagateTo: anObject
	^anObject isArray ifTrue: [IndexedWrapperHandle for: anObject] ifFalse: [anObject].! !

SCPropagateHandle subclass: #IncrementHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Tests-Classes'!

!IncrementHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 16:25'!
propagateTo: anObject
	^anObject isInteger 
		ifTrue: [
			Transcript show: (anObject + 1) printString.
			anObject + 1] 
		ifFalse: [
			Transcript show: anObject printString.
			anObject].! !

SCPropagateHandle subclass: #IndexedWrapperHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

IndexedWrapperHandle class
	instanceVariableNames: 'block'!

IndexedWrapperHandle class
	instanceVariableNames: 'block'!

!IndexedWrapperHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 17:09'!
initialize
	block := [:e | Transcript show: e printString;cr.
			e +1].! !

!IndexedWrapperHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 17:40'!
initializeFor: anObject
| handle |
	handle := super initializeFor: anObject.
	handle dontUseState.
	^ handle! !

!IndexedWrapperHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 16:57'!
propagateTo: anObject
	^block value: anObject. ! !

!SCPropagateHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 17:38'!
initializeFor: anObject
| handle |
	handle := super initializeFor: anObject.
	handle propagate.
	^ handle! !

!SCPropagateHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/11/2011 16:02'!
initializeFor: anObject to: aShadowClass
	| handle |
	handle := super initializeFor: anObject to: aShadowClass.
	handle propagate.
	^ handle! !

SCPropagateHandle subclass: #SCTransactionalHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone-Experimentation'!

!SCTransactionalHandle class methodsFor: 'as yet unclassified' stamp: 'jb 11/10/2011 16:17'!
propagateTo: anObject
	^SCTransactionalHandle for: anObject! !

SCTransactionalHandle subclass: #SCTransactionalUsingFactoryHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-SmartClone-Experimentation'!

SCTransactionalUsingFactoryHandle class
	instanceVariableNames: 'factory'!

SCTransactionalUsingFactoryHandle class
	instanceVariableNames: 'factory'!

!SCTransactionalUsingFactoryHandle class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:11'!
factory
	^factory! !

!SCTransactionalUsingFactoryHandle class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:11'!
factory: aFactory
	factory := aFactory! !

!SCTransactionalUsingFactoryHandle class methodsFor: 'as yet unclassified' stamp: 'jb 11/14/2011 15:11'!
propagateTo: anObject
		^(self factory) for: anObject.! !

SCHandle subclass: #StateSCHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-ExperimentationCWIP'!

!StateSCHandle class methodsFor: 'as yet unclassified' stamp: 'jb 10/12/2011 18:10'!
propagateTo: anObject
	^StateSCHandle for: anObject! !

SCHandle subclass: #TransactionHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-DesigningTM'!

TransactionHandle class
	instanceVariableNames: 'transaction'!

TransactionHandle class
	instanceVariableNames: 'transaction'!

!TransactionHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 15:10'!
propagateTo: anObject
	^anObject isInteger 
		ifFalse:[transaction propagateTo: anObject] 
		ifTrue: [anObject].! !

!TransactionHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 15:09'!
transaction: anObject
	transaction := anObject! !

SCHandle subclass: #WHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Worlds'!

WHandle class
	instanceVariableNames: 'world'!

WHandle class
	instanceVariableNames: 'world'!

!WHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 5/9/2012 15:04'!
initializeFor: anObject
	| inst |
	inst := super initializeFor: anObject.
	inst propagate.
	^inst! !

!WHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 5/9/2012 15:06'!
propagateTo: anObject
	^anObject isInteger 
		ifFalse:[world propagateTo: anObject] 
		ifTrue: [anObject].! !

!WHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 5/9/2012 14:37'!
world
	^world! !

!WHandle class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 5/9/2012 14:57'!
world: anObject
	world := anObject.! !

!WHandle methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 5/9/2012 16:34'!
copyStateOfObject: anObject
	| clon mock |
	mock := self class world mockId.
	clon:= anObject shallowCopy.
	"set all mock instance Var"
	1 to: (clon class instSize) do: [:e | clon instVarAt: e put:
(Association key: mock value: (anObject instVarAt: e)) ].
	"set all mock index Var"
	[1 to: (clon size) do: [:e | clon at: e put: (Association key: mock value: (anObject at: e))]] on: Error do: [].
	clone := clon.! !

Object subclass: #TAtomicManager
	instanceVariableNames: 'sanityCheck handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-TransactionnalMemoryCWIP'!

!TAtomicManager class methodsFor: 'as yet unclassified' stamp: 'jb 7/18/2011 12:01'!
managerFor: aHandle withTest: aBlock
	
	^self new 
		handle: aHandle;
		sanityCheck: aBlock;
		yourself.! !

!TAtomicManager methodsFor: 'as yet unclassified' stamp: 'jb 7/18/2011 12:00'!
check
	^[sanityCheck value: handle] on: Exception do:[false].
	! !

!TAtomicManager methodsFor: 'accessing' stamp: 'jb 7/18/2011 12:02'!
handle

	^ handle! !

!TAtomicManager methodsFor: 'accessing' stamp: 'jb 7/18/2011 12:02'!
handle: anObject

	handle := anObject! !

!TAtomicManager methodsFor: 'accessing' stamp: 'jb 7/18/2011 12:02'!
sanityCheck

	^ sanityCheck! !

!TAtomicManager methodsFor: 'accessing' stamp: 'jb 7/18/2011 12:02'!
sanityCheck: anObject

	sanityCheck := anObject! !

Object subclass: #Transaction
	instanceVariableNames: 'process transactionSuspend initReferences references atomikBlock handleClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-DesigningTM'!

Transaction subclass: #NestedTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-DesigningTM'!

!NestedTransaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
prepareReference: e
		TransactionsManager uniqueInstance claimRessources: e for: self.
		initReferences at: e put: ((self handleClass) for: e)

	! !

!NestedTransaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
prepareReferences
	initReferences keys do:[:e | 
		self prepareReference: e].
	references := initReferences copy.
	! !

!NestedTransaction methodsFor: 'handleManagement' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
propagateTo: anObject
	TransactionsManager uniqueInstance claimRessources: anObject for: self.
	references at: anObject put: ((self handleClass) for: anObject)! !

!NestedTransaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
references
	^references.! !

!NestedTransaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
references: anObject
	references := anObject.! !

!NestedTransaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
referencesHandled
	^references keys.! !

!NestedTransaction methodsFor: 'reseting' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
resetTransaction
	self referencesHandled do: [:e | TransactionsManager uniqueInstance release: e for: self].
	process terminate.
	transactionSuspend := true.! !

!NestedTransaction methodsFor: 'run' stamp: 'jeanbaptistearnaud 4/24/2012 14:22'!
run
	Transcript show: thisContext activeOuterContext;cr.
	Transcript show: thisContext activeOuterContext  activeOuterContext ;cr.
	Transcript show: thisContext activeOuterContext activeOuterContext activeOuterContext ;cr.
	
	self initializeTransaction.
	transactionSuspend ifFalse: [self runTransaction].! !

!NestedTransaction methodsFor: 'run' stamp: 'jeanbaptistearnaud 4/24/2012 14:13'!
runTransaction
	process := 	[atomikBlock valueWithArguments: (initReferences values).
		self finalizeTransaction.] fork.! !

!Transaction class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 14:53'!
new
	self error: 'use #new:with:'.
	! !

!Transaction class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/24/2012 14:03'!
new: atomikBlock with: anArray
	| instance |
	instance := super new.
	anArray do:[:e | instance initReferences at: e put: nil].
	instance atomikBlock: atomikBlock.
	^instance! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 14:48'!
atomikBlock: aBlock
	atomikBlock := aBlock.! !

!Transaction methodsFor: 'finalize' stamp: 'jeanbaptistearnaud 4/12/2012 14:40'!
commit
	references values installState.! !

!Transaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/12/2012 15:09'!
createNewHandleClass
	| class  |
	class := (Metaclass new 
	setFormat: (TransactionHandle class format);    	
	superclass: TransactionHandle class;               
	methodDict: (MethodDictionary new);
	new).
	class setName: 'TransactionHandleFor',(self hash printString).
	class setFormat: (TransactionHandle format).
	class superclass: TransactionHandle.
	class methodDict: (MethodDictionary new).
	class transaction: self.
	^class ! !

!Transaction methodsFor: 'check' stamp: 'jeanbaptistearnaud 4/12/2012 15:39'!
doIChange: anObject
	^(references at: anObject ifAbsent:[^false]) ~= anObject.! !

!Transaction methodsFor: 'finalize' stamp: 'jeanbaptistearnaud 4/12/2012 14:39'!
finalizeTransaction
	TransactionsManager uniqueInstance checkBeforeCommit: self.
	self commit.
	TransactionsManager uniqueInstance endOf: self.! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 15:06'!
handleClass
	^handleClass! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 14:36'!
handles
	^references values.! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 15:27'!
initReferences
	^initReferences.! !

!Transaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/12/2012 20:53'!
initialize
	transactionSuspend := false.
	references := IdentityDictionary new.
	initReferences := IdentityDictionary new.
	handleClass := self createNewHandleClass.
	! !

!Transaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/12/2012 20:35'!
initializeTransaction
	self prepareReferences.
	transactionSuspend := false.! !

!Transaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/12/2012 15:04'!
prepareReference: e
		TransactionsManager uniqueInstance claimRessources: e for: self.
		initReferences at: e put: ((self handleClass) for: e)

	! !

!Transaction methodsFor: 'initialization' stamp: 'jeanbaptistearnaud 4/12/2012 15:25'!
prepareReferences
	initReferences keys do:[:e | 
		self prepareReference: e].
	references := initReferences copy.
	! !

!Transaction methodsFor: 'handleManagement' stamp: 'jeanbaptistearnaud 4/12/2012 15:03'!
propagateTo: anObject
	TransactionsManager uniqueInstance claimRessources: anObject for: self.
	references at: anObject put: ((self handleClass) for: anObject)! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 14:57'!
references
	^references.! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 14:47'!
references: anObject
	references := anObject.! !

!Transaction methodsFor: 'access' stamp: 'jeanbaptistearnaud 4/12/2012 14:35'!
referencesHandled
	^references keys.! !

!Transaction methodsFor: 'reseting' stamp: 'jeanbaptistearnaud 4/12/2012 20:22'!
resetTransaction
	self referencesHandled do: [:e | TransactionsManager uniqueInstance release: e for: self].
	process terminate.
	transactionSuspend := true.! !

!Transaction methodsFor: 'run' stamp: 'jeanbaptistearnaud 4/24/2012 14:03'!
run

	
	Transcript show: thisContext activeOuterContext;cr.
	self initializeTransaction.
	transactionSuspend ifFalse: [self runTransaction].! !

!Transaction methodsFor: 'run' stamp: 'jeanbaptistearnaud 4/12/2012 15:26'!
runTransaction
	process := 	[atomikBlock valueWithArguments: (initReferences values).
		self finalizeTransaction.] fork.! !

Object subclass: #TransactionalHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-TransactionnalMemoryCWIP'!

!TransactionalHandle class methodsFor: 'as yet unclassified' stamp: 'JB 12/2/2010 15:07'!
debugFor: t1 
	| t2 t3 |
	t1 isLiteral
		ifTrue: [^ t1].
	t2 := self createHandle.
	t3 := Class new setFormat: t1 class format;
				 superclass: t1 class superclass;
				 setName: 'TM' , t1 class name;
				 methodDict: t1 class methodDict.
	t2 initializeHandleWith: t1 to: t3.
	^ t2! !

!TransactionalHandle class methodsFor: 'as yet unclassified' stamp: 'jb 11/4/2011 13:14'!
for: anObject
	^(anObject isKindOf: Class) 
		ifTrue: [ClassSCHandle for: anObject]
		ifFalse: [SCHandle for: anObject].! !

!TransactionalHandle methodsFor: 'as yet unclassified' stamp: 'bj 3/28/2011 10:48'!
initialize
	super initialize.
	self useHandleState.
	self useShadowBehavior! !

Object subclass: #TransactionalManager
	instanceVariableNames: 'sanityCheck handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-TransactionnalMemoryCWIP'!

Object subclass: #TransactionsManager
	instanceVariableNames: 'objectRegistration transactionSuspend objectLock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-DesigningTM'!

TransactionsManager class
	instanceVariableNames: 'uniqueInstance'!

TransactionsManager class
	instanceVariableNames: 'uniqueInstance'!

!TransactionsManager class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 15:33'!
new
	self error: 'use uniqueInstance'! !

!TransactionsManager class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 16:13'!
resetUniqueInstance
	uniqueInstance := nil.! !

!TransactionsManager class methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 15:32'!
uniqueInstance
	^uniqueInstance ifNil:[uniqueInstance := super new].! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 19:49'!
checkBeforeCommit: aTransaction
	"lock all" 
	objectLock isEmpty ifTrue: [
		objectLock addAll: (aTransaction referencesHandled).
		"check who which can be rerun"
		aTransaction referencesHandled do: [:e || collection |
			(aTransaction doIChange: e) ifTrue: [
				self conflictFor: e priorityFor: aTransaction ].
			self release: e for: aTransaction.
			]] ifFalse: [
		^self relaunchAsSoonAsPossible: aTransaction].
	
	! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 19:49'!
claimRessources: anObject for: aTransaction
	| collection |
	
	(objectLock includes: anObject) ifTrue: [
		^self relaunchAsSoonAsPossible: aTransaction].
	collection := (objectRegistration at: anObject ifAbsentPut:[OrderedCollection new]).
	"collection do: [:eachTransaction | (eachTransaction doIChange: anObject) 
				ifTrue: [^self conflictFor: anObject priorityFor: eachTransaction ]]."
	collection add: aTransaction.
	! !

!TransactionsManager methodsFor: 'conflict' stamp: 'jeanbaptistearnaud 4/12/2012 20:29'!
conflictFor: anObject priorityFor: eachTransaction
	| col resendCol |
	Transcript show: 'conflict for ',(anObject printString);cr.
	resendCol := OrderedCollection new.
	col := (objectRegistration at: anObject).
	col remove: eachTransaction.
	col do: [:e | e resetTransaction.
		resendCol add: e.
		].
	col add: eachTransaction.
	objectRegistration at: anObject put: col.
	transactionSuspend at: eachTransaction put: resendCol.! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 17:05'!
endOf: aTransaction
	
	aTransaction referencesHandled do: [:e | objectLock remove: e ].
	self launchConflictingTransaction: aTransaction.
! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 14:08'!
initialize
	objectRegistration := Dictionary new.
	transactionSuspend := Dictionary new.
	objectLock := OrderedCollection new. ! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 20:31'!
launchConflictingTransaction: aTransaction
	
	| col |
	col := Set new.
	col addAll: (transactionSuspend at: #fastDelay ifAbsent:[OrderedCollection new]).
	col addAll: (transactionSuspend at: aTransaction ifAbsent:[OrderedCollection new]).
	(transactionSuspend at: aTransaction ifPresent:[transactionSuspend removeKey: aTransaction]).
	(transactionSuspend at: #fastDelay ifPresent:[transactionSuspend removeKey: #fastDelay]).
	col do: [:e | e run].
	! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 14:07'!
relaunchAsSoonAsPossible: aTransaction
	(transactionSuspend at: #fastDelay ifAbsentPut:[OrderedCollection new]) add: aTransaction.! !

!TransactionsManager methodsFor: 'as yet unclassified' stamp: 'jeanbaptistearnaud 4/12/2012 17:43'!
release: anObject for: aTransaction
 	| col | 
	col := (objectRegistration at: anObject).
	col remove: aTransaction.
	col isEmpty ifTrue:[objectRegistration removeKey: anObject].
	! !

Object subclass: #Worlds
	instanceVariableNames: 'mockId handles parent hClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Handles-Worlds'!

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 14:57'!
createNewHandleClass
	| class  |
	class := (Metaclass new 
	setFormat: (WHandle class format);    	
	superclass: WHandle class;               
	methodDict: (MethodDictionary new);
	new).
	class setName: 'WHandle',(self hash printString).
	class setFormat: (WHandle format).
	class superclass: WHandle.
	class methodDict: (MethodDictionary new).
	class world: self.
	^class ! !

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 15:16'!
for: value 
	handles at: value put: (hClass for: value).
	^handles at: value.! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:53'!
handles

	^ handles! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:54'!
handles: anObject
	handles := anObject.! !

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 15:11'!
initialize
	mockId := Object new.
	parent := nil.
	handles := Dictionary new.
	hClass := self createNewHandleClass.! !

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 17:00'!
isMockObject: anObject
	| value |
	value := handles at: anObject ifAbsent:[^nil].
	^value = mockId 
		ifTrue:[nil]
		ifFalse:[value].! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:53'!
mockId

	^ mockId! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:53'!
mockId: anObject

	mockId := anObject! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:53'!
parent

	^ parent! !

!Worlds methodsFor: 'accessing' stamp: 'jeanbaptistearnaud 5/9/2012 13:53'!
parent: anObject

	parent := anObject! !

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 17:01'!
propagateTo: anObject
	| value v |
	value := self isMockObject: anObject.
	^(value isNil) 
			ifTrue: [self sendToParent: anObject]
			ifFalse:[value].
	! !

!Worlds methodsFor: 'initialize' stamp: 'jeanbaptistearnaud 5/9/2012 17:01'!
sendToParent: anObject
	^parent ifNil: [anObject value]ifNotNil:[parent propagateTo: anObject].! !
IndexedWrapperHandle initialize!
